#include <qpainter.h>
#include <qtextcodec.h>
#include "aboutw.H"

AboutWindow::AboutWindow(QPixmap *background,QWidget *parent,char *name) : QWidget(parent,name){
  bkg=background;
  QTextCodec *tc=QTextCodec::codecForName("iso8859-2");
  srt[srt_title]=new QSimpleRichText(tc->toUnicode("<h2><font color=darkblue>Demonstracja algorytmu RSA</font></h2>"),font());
  srt[srt_copyright]=new QSimpleRichText(tc->toUnicode("Copyright by Micha Tana (mike@thanedd.amu.edu.pl), 2002"),font());
  srt[srt_prawa]=new QSimpleRichText(tc->toUnicode("Program udostpniony na licencji GPL. Zabronione jest usuwanie i/lub modyfikacja copyrightu ktry wanie czytasz. Poza tym adne prawa nie zastrzeone. Kopiowanie surowo wskazane. Autor nie bierze odpowiedzialnoci za skutki dziaania (lub niedziaania) programu."),font());
  srt[srt_biblioteki]=new QSimpleRichText(tc->toUnicode("Program wykorzystuje biblioteki GNU MP 4.1 oraz QT 3.0.6. Licencje i inne informacje dotyczce tych bibliotek dostpne s na http://www.swox.com/gmp/  oraz  http://www.trolltech.no"),font());
  srt[srt_ecb]=new QSimpleRichText(tc->toUnicode("Program jest jedynie demonstracj dziaania algorytmu RSA dla celw edukacyjnych. eby nie wprowadza dodatkowch poj zastosowano najprostszy moliwy schemat szyfrowania (tzw. ECB, z 1-bajtowym blokiem danych) ktry czyni kady szyfr trywialnie prostym do zamania metod analizy czstoci. Szyfr generowany przez ten program nie nadaje si do jakichkolwiek zastosowa praktycznych!"),font());
  srt[srt_wyklad]=new QSimpleRichText(tc->toUnicode("Program jest demonstracj do wykadu \"Informatyka kwantowa\" z cyklu \"Zaproszenie do fizyki\", wygoszonego przez <nobr>prof. dr hab R. Tanasia</nobr> w dniu 5 listopada 2002 na Wydziale Fizyki UAM. Wykad jest dostpny na http://zon8.physd.amu.edu.pl/~tanas/"),font());
}

AboutWindow::~AboutWindow(){
  for (int i=0; i<nr_srt; i++) delete srt[i];
}

void AboutWindow::paintEvent(QPaintEvent *){
  QPixmap pm(size());
  QPainter p;
  p.begin(&pm);
  if (bkg->isNull())
    pm.fill(backgroundColor());
  else
    p.drawTiledPixmap(0,0,width(),height(),*bkg);
  int cy=5;
  srt[srt_title]->draw(&p,width()/2-srt[srt_title]->widthUsed()/2,cy,QRegion(0,0,width(),height()),colorGroup());
  cy+=srt[srt_title]->height()+10;
  srt[srt_copyright]->draw(&p,width()/2-srt[srt_copyright]->widthUsed()/2,cy,QRegion(0,0,width(),height()),colorGroup());
  cy+=srt[srt_copyright]->height()+10;
  srt[srt_wyklad]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
  cy+=srt[srt_wyklad]->height()+40;
  srt[srt_prawa]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
  cy+=srt[srt_prawa]->height()+15;
  srt[srt_biblioteki]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
  cy+=srt[srt_biblioteki]->height()+15;
  srt[srt_ecb]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
  p.end();
  bitBlt(this,0,0,&pm);
}

void AboutWindow::resizeEvent(QResizeEvent *){
  for (int i=0; i<nr_srt; i++) srt[i]->setWidth(width());
}




