#ifndef BREAKW_H
#define BREAKW_H

#include <qpixmap.h>
#include <qsimplerichtext.h>
#include <qtextview.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qprogressbar.h>
#include <qtimer.h>
#include <qdatetime.h>
#include "rsa.H"

class BreakWindow : public QWidget {
  Q_OBJECT;
  RSAKey *pubkey;
  RSAEncodedMsg *msg;
  QPixmap *bkg_pixmap;
  
  mpz_class p,q,fi,d;
  mpz_class sqrt_n,sn1000;
  

  static const int nr_srt=10;
  static const int srt_title=0;
  static const int srt_brakkluczy=1;
  static const int srt_kpub=2;
  static const int srt_tekstjawny=3;
  static const int srt_tekstascii=4;
  static const int srt_tekstrsa=5;
  static const int srt_brakmsg=6;
  static const int srt_noprivkeyopis=7;
  static const int srt_pq=8;
  static const int srt_fid=9;
  //  static const int srt_nlc=10;
  QSimpleRichText *srt[nr_srt];
  
  static const int nr_tv=3;
  static const int tv_ascii=0;
  static const int tv_rsa=1;
  static const int tv_plain=2;
  QTextView *tv[nr_tv];

  static const int nr_bt=1;
  static const int bt_rozklad=0;
  QPushButton *bt[nr_bt];

  static const int nr_pb=1;
  static const int pb_rozklad=0;
  QProgressBar *pb[nr_pb];
  
  QTimer *qtm;
  QTime q_time;
  int q_time_msec;
public:
  BreakWindow(RSAKey *,RSAEncodedMsg *,QPixmap *,QWidget * =NULL,char * =NULL);
  ~BreakWindow();
protected:
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);
public slots:
  void updateTV();
  void rozklad_n();
  void rozklad_n_step();
  void rozklad_n_koniec();
private:
  QSimpleRichText *kpub2srt();
  QSimpleRichText *pq2srt();
  QSimpleRichText *fid2srt();
  QSimpleRichText *noprivkeys2srt();
};
#endif BREAKW_H


