#include <qpainter.h>
#include <qtextcodec.h>
#include <qtimer.h>
#include "breakw.H"

BreakWindow::BreakWindow(RSAKey *kpub,RSAEncodedMsg *m,QPixmap *bkg,QWidget *parent,char *name) : QWidget(parent,name){
  pubkey=kpub;
  bkg_pixmap=bkg;
  msg=m;
  p=0; q=0;
  
  QTextCodec *tc=QTextCodec::codecForName("iso8859-2");
  srt[srt_title]=new QSimpleRichText(tc->toUnicode("<h2><font color=darkblue>amanie szyfru RSA</font></h2>"),font());
  srt[srt_brakkluczy]=new QSimpleRichText(tc->toUnicode("<h2><font color=red>Najpierw wygeneruj klucze!</font></h2>"),font());
  srt[srt_brakmsg]=new QSimpleRichText(tc->toUnicode("<h2><font color=red>Najpierw co zaszyfuj!</font></h2>"),font());
  srt[srt_kpub]=kpub2srt();
  srt[srt_tekstjawny]=new QSimpleRichText(tc->toUnicode("co po zamianie ASCII na litery daje"),font());
  srt[srt_tekstascii]=new QSimpleRichText(tc->toUnicode("znajc d i n w normalny sposb (M=C^d mod n) dekodujemy kryptogram"),font());
  srt[srt_tekstrsa]=new QSimpleRichText(tc->toUnicode("Mamy zaszyfrowany tekst"),font());
  srt[srt_noprivkeyopis]=noprivkeys2srt();
  srt[srt_pq]=pq2srt();
  srt[srt_fid]=fid2srt();
  //  srt[srt_nlc]=ilcyfr2srt(n);
  for (int i=0; i<nr_tv; i++) tv[i]=new QTextView(this);
  for (int i=0; i<nr_bt; i++) bt[i]=new QPushButton(this);
  for (int i=0; i<nr_pb; i++) pb[i]=new QProgressBar(this);
  if ((pubkey->e>=2)&&(pubkey->n>=2)&&(msg->len>0)){
    for (int i=0; i<nr_tv; i++) tv[i]->show();
    for (int i=0; i<nr_bt; i++) bt[i]->show();
    for (int i=0; i<nr_pb; i++) pb[i]->show();
  } else {
    for (int i=0; i<nr_tv; i++) tv[i]->hide();
    for (int i=0; i<nr_bt; i++) bt[i]->hide();
    for (int i=0; i<nr_pb; i++) pb[i]->hide();
  }
  bt[bt_rozklad]->setText(tc->toUnicode("Roz n na czynniki pierwsze"));
  connect(bt[bt_rozklad],SIGNAL(clicked()),this,SLOT(rozklad_n()));
  pb[pb_rozklad]->setProgress(0);
  pb[pb_rozklad]->hide();
  tv[tv_ascii]->hide();
  tv[tv_plain]->hide();
  updateTV();
  qtm=new QTimer(this);
}

BreakWindow::~BreakWindow(){
  for (int i=0; i<nr_srt; i++) delete srt[i];
  for (int i=0; i<nr_tv; i++) delete tv[i];
  for (int i=0; i<nr_bt; i++) delete bt[i];
  for (int i=0; i<nr_pb; i++) if (pb[i]!=NULL) delete pb[i];
  delete qtm;
}

void BreakWindow::paintEvent(QPaintEvent *){

  QPixmap pm(size());
  QPainter p;
  p.begin(&pm);
  if (bkg_pixmap->isNull())
    pm.fill(backgroundColor());
  else 
    p.drawTiledPixmap(0,0,width(),height(),*bkg_pixmap);
  int cy=5;
  srt[srt_title]->draw(&p,width()/2-srt[srt_title]->widthUsed()/2,cy,QRegion(0,0,width(),height()),colorGroup());
  cy+=srt[srt_title]->height();
  if ((pubkey->e<2)||(pubkey->n<2)){
    cy+=srt[srt_title]->height();
    srt[srt_brakkluczy]->draw(&p,width()/2-srt[srt_brakkluczy]->widthUsed()/2,cy,QRegion(0,0,width(),height()),colorGroup());
    cy+=srt[srt_brakkluczy]->height();
  }
  if ((pubkey->e>=2)&&(pubkey->n>=2)){
    if (msg->len<=0){
      srt[srt_brakmsg]->draw(&p,width()/2-srt[srt_brakmsg]->widthUsed()/2 ,cy,QRegion(0,0,width(),height()),colorGroup());
      cy+=srt[srt_brakmsg]->height();
    } else {
      srt[srt_tekstrsa]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
      cy=tv[tv_rsa]->y()+tv[tv_rsa]->height()+5;
      srt[srt_kpub]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
      cy+=srt[srt_kpub]->height();
      srt[srt_noprivkeyopis]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
      cy+=srt[srt_noprivkeyopis]->height();
      if (q>0){
	cy=bt[bt_rozklad]->y()+bt[bt_rozklad]->height()+5;
	srt[srt_pq]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
	cy+=srt[srt_pq]->height()+5;
	srt[srt_fid]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
	cy+=srt[srt_fid]->height()+10;
	srt[srt_tekstascii]->draw(&p,5,cy,QRegion(0,0,width(),height()),colorGroup());
	srt[srt_tekstjawny]->draw(&p,5,tv[tv_ascii]->y()+tv[tv_ascii]->height(),QRegion(0,0,width(),height()),colorGroup());
      }
    }
  }
  p.end();
  bitBlt(this,0,0,&pm);
  for (int i=0; i<nr_tv; i++) tv[i]->repaint();
  for (int i=0; i<nr_bt; i++) bt[i]->repaint();
  for (int i=0; i<nr_pb; i++) if (pb[i]!=NULL) pb[i]->repaint();
}

void BreakWindow::resizeEvent(QResizeEvent *){
  for (int i=0; i<nr_srt; i++) srt[i]->setWidth(width());
  tv[tv_rsa]->setGeometry(0,srt[srt_title]->height()+srt[srt_tekstrsa]->height()+10,width(),6*srt[srt_kpub]->height());
  bt[bt_rozklad]->setGeometry(width()/4,tv[tv_rsa]->y()+tv[tv_rsa]->height()+srt[srt_kpub]->height()+srt[srt_noprivkeyopis]->height()+10,width()/2,srt[srt_kpub]->height()+10);
  pb[pb_rozklad]->setGeometry(5,bt[bt_rozklad]->y()+bt[bt_rozklad]->height()+5,width()-10,30);
  tv[tv_ascii]->setGeometry(0,bt[bt_rozklad]->y()+bt[bt_rozklad]->height()+5+srt[srt_pq]->height()+5+srt[srt_fid]->height()+10+srt[srt_tekstascii]->height()+5,width(),3*srt[srt_tekstrsa]->height());
  tv[tv_plain]->setGeometry(0,tv[tv_ascii]->y()+tv[tv_ascii]->height()+srt[srt_tekstjawny]->height()+5,width(),3*srt[srt_tekstrsa]->height());
  updateTV();
}

QSimpleRichText * BreakWindow::kpub2srt(){
  char ds[10240],ns[10240];
  mpz_get_str(ds,10,pubkey->e.get_mpz_t());
  mpz_get_str(ns,10,pubkey->n.get_mpz_t());
  QString col("blue");
  return new QSimpleRichText(QString("<nobr>i znamy klucz publiczny <font color=")+col+QString(">(e,n)=(")+QString(ds)+QString(",")+QString(ns)+QString(")</font></nobr>"),font());
}

QSimpleRichText * BreakWindow::pq2srt(){
  char ps[10240],qs[10240];
  mpz_get_str(ps,10,p.get_mpz_t());
  mpz_get_str(qs,10,q.get_mpz_t());
  QString qs_sec;
  qs_sec.setNum(q_time_msec/1000.0);
  QTextCodec *tc=QTextCodec::codecForName("iso8859-2");
  return new QSimpleRichText(tc->toUnicode(QString("gotowe: <font color=blue>p=")+QString(ps)+QString("</font>, <font color=blue>q=")+QString(qs)+QString("</font>, rozkad trwa <font color=blue>")+QString(qs_sec)+QString("</font>s")),font());
}

QSimpleRichText * BreakWindow::fid2srt(){
  char fis[10240],ds[10240];
  mpz_get_str(fis,10,fi.get_mpz_t());
  mpz_get_str(ds,10,d.get_mpz_t());
  QTextCodec *tc=QTextCodec::codecForName("iso8859-2");
  return new QSimpleRichText(tc->toUnicode(QString("Obliczamy <font color=blue>fi(n)=")+QString(fis)+QString("</font> a nastpnie <font color=blue>d=")+QString(ds)+QString("</font>")),font());
}


void BreakWindow::updateTV(){
  if (msg->len>0){
    tv[tv_rsa]->setText(QString(""));
    for (int i=0; i<msg->len; i++){
      char t1[10240];
      t1[0]=0;
      mpz_get_str(t1,10,msg->msg[i]);
      QString ptvr=tv[tv_rsa]->text();
      tv[tv_rsa]->setText(tv[tv_rsa]->text()+QString(t1)+QString(", "));
      if (tv[tv_rsa]->visibleWidth()<tv[tv_rsa]->contentsWidth()){
	tv[tv_rsa]->setText(ptvr+QString("<br>")+QString(t1)+QString(", "));
	
      }
    }
    char *t=new char[msg->len+1];
    t[msg->len]=0;
    RSAKey privkey;
    privkey.n=pubkey->n;
    privkey.d=d;
    msg->decode(t,privkey);
    tv[tv_ascii]->setText("");
    for (unsigned int i=0; i<strlen(t); i++){
      QString si;
      si.setNum(int(t[i]));
      QString ptva=tv[tv_ascii]->text();
      tv[tv_ascii]->setText(tv[tv_ascii]->text()+si+QString(", "));
      if (tv[tv_ascii]->visibleWidth()<tv[tv_ascii]->contentsWidth()){
	tv[tv_ascii]->setText(ptva+QString("<br>")+si+QString(", "));
	
      }
    }
    tv[tv_plain]->setText(t);
    delete[] t;
  }
}

void BreakWindow::rozklad_n_koniec(){
  //  cout<<"sn1000="<<sn1000<<" p="<<p<<" q="<<q<<endl;
  qtm->stop();
  q_time_msec=q_time.elapsed();
  if (q==0) {
    p=0;
    tv[tv_ascii]->hide();
    tv[tv_plain]->hide();
  } else {
    tv[tv_ascii]->show();
    tv[tv_plain]->show();
  }
  if (q!=0){
    pb[pb_rozklad]->hide();
    fi=(p-1)*(q-1);
    d=invert(pubkey->e,fi);
    delete srt[srt_pq]; srt[srt_pq]=pq2srt(); srt[srt_pq]->setWidth(width());
    delete srt[srt_fid]; srt[srt_fid]=fid2srt(); srt[srt_fid]->setWidth(width());
    disconnect(qtm,SIGNAL(timeout()),this,SLOT(rozklad_n_step()));
    updateTV();
  }
  repaint(FALSE);
}

/*
void BreakWindow::rozklad_n_step_old(){
//  cout<<"p="<<p<<" sn1000="<<sn1000<<" prog="<<pb[pb_rozklad]->progress()<<endl;
if (sn1000>0)
    if (p%sn1000==0){
      pb[pb_rozklad]->setProgress(pb[pb_rozklad]->progress()+1);
      pb[pb_rozklad]->repaint(FALSE);
    }
  if (pubkey->n%p==0){
    q=pubkey->n/p;
    rozklad_n_koniec();
  }
  p++;
  if (p>sqrt_n) rozklad_n_koniec();
}
*/

void BreakWindow::rozklad_n_step(){
  //  cout<<"sqrt(n)="<<sqrt_n<<" p="<<p<<" q="<<q<<endl;
  for (mpz_class i=p; i<=p+sn1000; i+=2){
    //    cout<<"i="<<i<<endl;
    if (pubkey->n%i==0){
      p=i;
      q=pubkey->n/p;
      rozklad_n_koniec();
      return;
    }
    if (i>sqrt_n) {
      p=0;
      q=0;
      rozklad_n_koniec();
      return;
    }
  }
  p=p+sn1000;
  if (p%2==0) p--;
  pb[pb_rozklad]->setProgress(pb[pb_rozklad]->progress()+1);
  pb[pb_rozklad]->repaint(FALSE);
}

void BreakWindow::rozklad_n(){
  pb[pb_rozklad]->setTotalSteps(1000);
  pb[pb_rozklad]->setProgress(0);
  pb[pb_rozklad]->show();
  if (pubkey->n%2==0){
    q_time.start();
    p=2;
    q=pubkey->n/2;
    rozklad_n_koniec();
  } else {
    sqrt_n=sqrt(pubkey->n)+1;
    sn1000=sqrt_n/1000;
    if (sn1000==0){
      q_time.start();
      for (mpz_class i=3; i<=sqrt_n; i+=2){
	if (pubkey->n%i==0){
	  p=i;
	  q=pubkey->n/p;
	  rozklad_n_koniec();
	}
      }
    } else {
      p=3;
      q=0;
      fi=0;
      d=0;
      q_time_msec=0;
      connect(qtm,SIGNAL(timeout()),this,SLOT(rozklad_n_step()));
      q_time.start();
      qtm->start(0,FALSE);
    }
  }
}

QSimpleRichText * BreakWindow::noprivkeys2srt(){
  char ns[10240];
  QTextCodec *tc=QTextCodec::codecForName("iso8859-2"); 
  mpz_get_str(ns,10,pubkey->n.get_mpz_t());
  QString cyfry;
  cyfry.setNum(strlen(ns));
  return new QSimpleRichText(tc->toUnicode("Nie znamy klucza prywatnego (d,n). Wiemy jednak e n jest takie samo jak w kluczu publicznym, <nobr>d=e^-1 mod fi(n)</nobr>, a <nobr>fi(n)=(p-1)*(q-1)</nobr>. Do odtworzenia klucza prywatnego potrzebujemy zatem p i q. Poniewa znamy n=p*q, musimy rozoy ")+cyfry+tc->toUnicode("-cyfrow liczb n na czynniki pierwsze."),font());
}

  /*
  for (p=2; p<=sqrt_n; p++){
    if (sn1000>0)
      if (p%sn1000==0){
	pb[pb_rozklad]->setProgress(pb[pb_rozklad]->progress()+1);
	pb[pb_rozklad]->update();
      }
    if (pubkey->n%p==0){
      q=p/pubkey->n;
      return;
    }
  }
  p=0;
  q=0; 
  }
  */
