#ifndef DECODEW_H
#define DECODEW_H

#include <qpixmap.h>
#include <qsimplerichtext.h>
#include <qtextview.h>
#include <qwidget.h>
#include "rsa.H"

class DecodeWindow : public QWidget {
  Q_OBJECT;
  RSAKey *privkey;
  RSAEncodedMsg *msg;
  QPixmap *bkg_pixmap;
  
  static const int nr_srt=7;
  static const int srt_title=0;
  static const int srt_brakkluczy=1;
  static const int srt_kpriv=2;
  static const int srt_tekstjawny=3;
  static const int srt_tekstascii=4;
  static const int srt_tekstrsa=5;
  static const int srt_brakmsg=6;
  QSimpleRichText *srt[nr_srt];
  
  static const int nr_tv=3;
  static const int tv_ascii=0;
  static const int tv_rsa=1;
  static const int tv_plain=2;
  QTextView *tv[nr_tv];
public:
  DecodeWindow(RSAKey *,RSAEncodedMsg *,QPixmap *,QWidget * =NULL,char * =NULL);
  ~DecodeWindow();
protected:
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);
public slots:
  void updateTV();
private:
   QSimpleRichText *kpriv2srt();
};
#endif DECODEW_H
