#ifndef ENCODEW_H
#define ENCODEW_H

#include <qmultilineedit.h>
#include <qpixmap.h>
#include <qsimplerichtext.h>
#include <qtextview.h>
#include <qwidget.h>
#include "rsa.H"

class EncodeWindow : public QWidget {
  Q_OBJECT;
  RSAKey *pubkey;
  RSAEncodedMsg *msg;
  QPixmap *bkg_pixmap;

  static QString plain_text;
  
  static const int nr_srt=6;
  static const int srt_title=0;
  static const int srt_brakkluczy=1;
  static const int srt_kpub=2;
  static const int srt_tekstjawny=3;
  static const int srt_tekstascii=4;
  static const int srt_tekstrsa=5;
  QSimpleRichText *srt[nr_srt];
  
  QMultiLineEdit *mln;

  static const int nr_tv=2;
  static const int tv_ascii=0;
  static const int tv_rsa=1;
  QTextView *tv[nr_tv];
public:
  EncodeWindow(RSAKey *,RSAEncodedMsg *,QPixmap *,QWidget * =NULL,char * =NULL);
  ~EncodeWindow();
protected:
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);
private slots:
  void updateTV();
private:
   QSimpleRichText *kpub2srt();
};
#endif ENCODEW_H
