#ifndef KEYGENW_H
#define KEYGENW_H

#include <qlineedit.h>
#include <qpixmap.h>
#include <qpushbutton.h>
#include <qsimplerichtext.h>
#include <qwidget.h>
#include "rsa.H"

class KeyGenWindow : public QWidget{
  Q_OBJECT;
  RSAKey *pubkey,*privkey;
  static const int nr_le=3;
  static const int le_p=0;
  static const int le_q=1;
  static const int le_e=2;
  QLineEdit *le[nr_le];
  static const int nr_srt=21;
  static const int srt_title=0;
  static const int srt_opispq=1;
  static const int srt_ple=2;
  static const int srt_qle=3;
  static const int srt_p=4;
  static const int srt_q=5;
  static const int srt_opisn=6;
  static const int srt_n=7;
  static const int srt_opisfi=8;
  static const int srt_fi=9;
  static const int srt_opise=10;
  static const int srt_ele=11;
  static const int srt_e=12;
  static const int srt_opisd=13;
  static const int srt_d=14;
  static const int srt_opisklucze=15;
  static const int srt_kpub=16;
  static const int srt_kpriv=17;
  static const int srt_qlc=18;
  static const int srt_plc=19;
  static const int srt_nlc=20;
  QSimpleRichText *srt[nr_srt];

  static mpz_class p,q;
  mpz_class n,fi,d,e;

  QPixmap *bkg_pixmap;
  // static const int nr_bt=1;
  // static const int bt_genn
public:
  KeyGenWindow(RSAKey *,RSAKey *,QPixmap *,QWidget * =NULL,char * =NULL);
  ~KeyGenWindow();
protected:
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);
private slots:
  void changeP(const QString &);
  void changeQ(const QString &);
  void changeE(const QString &);
private:
  void updateAll();
  void updateNFiED();
  void updateD();
  void updateKeys();
  QSimpleRichText *p2srt();
  QSimpleRichText *q2srt();
  QSimpleRichText *n2srt();
  QSimpleRichText *fi2srt();
  QSimpleRichText *e2srt();
  QSimpleRichText *d2srt();
  QSimpleRichText *kpub2srt();
  QSimpleRichText *kpriv2srt();
  QSimpleRichText *ilcyfr2srt(mpz_class);
};

#endif
