#ifndef MAINW_H
#define MAINW_H

#include <qmenubar.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qwidget.h>
#include "keygenw.H"
#include "encodew.H"
#include "decodew.H"
#include "breakw.H"
#include "aboutw.H"
#include "rsa.H"

class MainWindow : public QWidget{
  Q_OBJECT;
  static const int mb_about=0;
  static const int mb_keygen=1;
  static const int mb_encode=2;
  static const int mb_decode=3;
  static const int mb_break=4;

  QMenuBar *mb;
  //  static const int nr_pm=
  //  QPopupMenu *pm[nr_pm];
  KeyGenWindow *kgw;
  EncodeWindow *ew;
  DecodeWindow *dw;
  BreakWindow *bw;
  AboutWindow *aw;

  RSAKey pub,priv;
  char *t;
  RSAEncodedMsg msg;
  QPixmap bkg_pixmap;
public:
  MainWindow();
  ~MainWindow();
protected:
  void paintEvent(QPaintEvent *);
  void resizeEvent(QResizeEvent *);
  //  void fontChange(const QFont &);
private slots:
  void openAbout();
  void openKeygen();
  void openEncode();
  void openDecode();
  void openBreak();
  void menuClicked(int);
private:
  void clearAll();
};

#endif
