#include <iostream.h>
#include <qtextcodec.h>
#include "mainw.H"

MainWindow::MainWindow(){
  kgw=NULL;
  ew=NULL;
  dw=NULL;
  bw=NULL;
  QTextCodec *tc=QTextCodec::codecForName("iso8859-2");
  mb=new QMenuBar(this);
  /*
  mb->insertItem("O programie",mb_about,mb_about);
  mb->insertItem("Klucze",mb_keygen,mb_keygen);
  mb->insertItem("Szyfrowanie",mb_encode,mb_encode);
  mb->insertItem("Deszyfrowanie",mb_decode,mb_decode);
  mb->insertItem(tc->toUnicode("amanie"),mb_break,mb_break);
  connect(mb,SIGNAL(activated(int)),this,SLOT(menuClicked(int)));
  */
  mb->insertItem("O programie",this,SLOT(openAbout()));
  mb->insertItem("Klucze",this,SLOT(openKeygen()));
  mb->insertItem("Szyfrowanie",this,SLOT(openEncode()));
  mb->insertItem("Deszyfrowanie",this,SLOT(openDecode()));
  mb->insertItem(tc->toUnicode("amanie"),this,SLOT(openBreak()));
  bkg_pixmap.load("./marble.png");
  aw=new AboutWindow(&bkg_pixmap,this);
  aw->show();

  //  kgw=new KeyGenWindow(&pub,&priv,&bkg_pixmap,this);
  // ew=new EncodeWindow(&pub,&bkg_pixmap,this);
}

MainWindow::~MainWindow(){
  delete mb;
  if (kgw!=NULL) delete kgw;
  if (ew!=NULL) delete ew;
  if (dw!=NULL) delete dw;
  if (bw!=NULL) delete bw;
  if (aw!=NULL) delete aw;
}

void MainWindow::paintEvent(QPaintEvent *){
  mb->repaint(FALSE);
  if (kgw!=NULL) kgw->repaint(FALSE);
  if (ew!=NULL) ew->repaint(FALSE);
  if (dw!=NULL) dw->repaint(FALSE);
  if (bw!=NULL) bw->repaint(FALSE);
  if (aw!=NULL) aw->repaint(FALSE);
}

void MainWindow::resizeEvent(QResizeEvent *){
  mb->setGeometry(0,0,width(),30);
  if (kgw!=NULL) kgw->setGeometry(0,mb->height(),width(),height()-mb->height());
  if (ew!=NULL) ew->setGeometry(0,mb->height(),width(),height()-mb->height());
  if (dw!=NULL) dw->setGeometry(0,mb->height(),width(),height()-mb->height());
  if (bw!=NULL) bw->setGeometry(0,mb->height(),width(),height()-mb->height());
  if (aw!=NULL) aw->setGeometry(0,mb->height(),width(),height()-mb->height());
}

void MainWindow::clearAll(){
  if (kgw!=NULL) delete kgw;
  if (ew!=NULL) delete ew;
  if (dw!=NULL) delete dw;
  if (bw!=NULL) delete dw;
  if (aw!=NULL) delete aw;
  kgw=NULL;
  ew=NULL;
  dw=NULL;
  bw=NULL;
  aw=NULL;
}

void MainWindow::openAbout()
{
  menuClicked(mb_about);
}

void MainWindow::openKeygen()
{
  menuClicked(mb_keygen);
}

void MainWindow::openEncode()
{
  menuClicked(mb_encode);
}
void MainWindow::openDecode()
{
  menuClicked(mb_decode);
}
void MainWindow::openBreak()
{
  menuClicked(mb_break);
}

void MainWindow::menuClicked(int id){
  clearAll();
  //  cout<<"id="<<id<<endl;
  
  if (id==mb_keygen){
    kgw=new KeyGenWindow(&pub,&priv,&bkg_pixmap,this);
    kgw->setGeometry(0,mb->height(),width(),height()-mb->height());
    kgw->show();
  }
  if (id==mb_encode){
    ew=new EncodeWindow(&pub,&msg,&bkg_pixmap,this);
    ew->setGeometry(0,mb->height(),width(),height()-mb->height());
    ew->show();
  }
  if (id==mb_decode){
    dw=new DecodeWindow(&priv,&msg,&bkg_pixmap,this);
    dw->setGeometry(0,mb->height(),width(),height()-mb->height());
    dw->show();
    dw->updateTV();
  }
  if (id==mb_break){
    bw=new BreakWindow(&pub,&msg,&bkg_pixmap,this);
    bw->setGeometry(0,mb->height(),width(),height()-mb->height());
    bw->show();
    bw->updateTV();
  }
  if (id==mb_about){
    aw=new AboutWindow(&bkg_pixmap,this);
    aw->setGeometry(0,mb->height(),width(),height()-mb->height());
    aw->show();
    //  aw->updateTV();
  } 
  repaint(FALSE);
}

