#ifndef RSA_H
#define RSA_H

#include <gmp.h>
#include <gmpxx.h>

struct RSAKey{
  mpz_class n,e,d;
  RSAKey();
};

struct RSAEncodedMsg{
  mpz_t *msg;
  int len;
  RSAEncodedMsg();
  ~RSAEncodedMsg();
  RSAEncodedMsg(const RSAEncodedMsg &);
  RSAEncodedMsg & operator=(const RSAEncodedMsg &);
  void setLen(int);
  void encode(const char *,RSAKey);
  void decode(char *,RSAKey);
};

mpz_class nextPrime(mpz_class);
mpz_class gcd(mpz_class,mpz_class);
mpz_class invert(mpz_class,mpz_class);
mpz_class powModN(mpz_class,mpz_class,mpz_class);
void factor2primes(mpz_class,mpz_class &,mpz_class &);

#endif
